<%
'
' CPAINT - Cross-Platform Asynchronous INterface Toolkit
'
' http://cpaint.sourceforge.net
' 
' released under the terms of the LGPL
' see http://www.fsf.org/licensing/licenses/lgpl.txt for details
'
' $Id$
' $Log$
' Revision 1.17  2005/09/03 16:40:21  saloon12yrd
' 2.0.1 RC1
' - improved AJAX capability check
' - taking use_cpaint_api == false into account in cpaint_call.call_proxy()
' - updated versions
' - updated changelog
' - added text changelog to release branch
'
' Revision 1.15  2005/08/24 13:52:11  wiley14
' Changed the way eval passes parameters (does not read the querystring or post variables, but passes a reference to them instead).  Eliminated checkblacklist function, as eval line is now "safer".
'
' Revision 1.14  2005/08/19 14:51:12  wiley14
' Last minute change
'
' Revision 1.13  2005/08/18 19:34:45  wiley14
' Minor error in cpaint_node.add_node
'
' Revision 1.12  2005/08/17 17:46:07  wiley14
' Updated location of api_query to make in-sync w/ PHP version
'
' Revision 1.11  2005/08/16 20:54:25  wiley14
' Synched with PHP backend, for the most part (see comments for register function).
'
' Revision 1.10  2005/08/09 00:56:51  wiley14
' Added hidden discovery variable, api_query, to assist in discovering remote scripts that use CPAINT v2.x or above
'
' Revision 1.9  2005/08/08 17:03:40  wiley14
' Added comments to code.  Removed encoding variables and functions from the cpaint_node class.  Approximately 99% compatibility with the existing API.
'
'
' @package    CPAINT
' @author     Paul Sullivan <wiley14@gmail.com>
' @author     Dominique Stender <dstender@st-webdevelopment.de>
' @copyright  Copyright (c) 2005 Paul Sullivan, Dominique Stender - http://cpaint.sourceforge.net


' cpaint base class
' @access	public
' @version	2.0.1
Class cpaint
	' response type (TEXT | OBJECT | XML)
	' @access	private
	' @var		string
	private response_type
	
	' basenode
	' @access	private
	' @var		cpaint_node
	private basenode
	
	' encoding type (ie:  UTF-8)
	' @access	private
	' @var		string
	private encoding
	
	' list of registered methods available through the cpaint api
	' @access	private
	' @var		Scripting.Dictionary
	private api_functions
	
	' version number
    ' @access 	private
    ' @var    	string     
     private versionNumber
	
	' class initalizer
	' @access	private
	' @return	none
	Private Sub Class_Initialize()
		set basenode = new cpaint_node
		versionNumber = "2.0.1"
		set api_functions = server.CreateObject("Scripting.Dictionary")
		basenode.set_name "ajaxResponse"
		if request.querystring("cpaint_response_type") <> "" then
			response_type = request.querystring("cpaint_response_type")
		elseif request.form("cpaint_response_type") <> "" then
			response_type = request.form("cpaint_response_type")
		else
			response_type = "TEXT"
		end if		
	End Sub
	
	' code-runner
	' NOTE:  input_encoding not optional!  if it needs to be the default, simply pass an empty (not null) string
	' @access	public
	' @param	string		input_encoding		encoding type
	' @return	none
	Public Sub start(input_encoding)
		if input_encoding = "" then input_encoding = "UTF-8"
		eval_string = ""
		encoding = input_encoding
		if request.querystring("cpaint_function") <> "" then
			user_function = request.querystring("cpaint_function")
			for i = 1 to request.querystring("cpaint_argument[]").count
				eval_string = eval_string & "request.querystring(""cpaint_argument[]"")(" & i & ")"
				if i <> request.querystring("cpaint_argument[]").count then eval_string = eval_string & ", "
			next
		elseif request.form("cpaint_function") <> "" then
			user_function = request.form("cpaint_function")
			for i = 1 to request.form("cpaint_argument[]").count
				eval_string = eval_string & "request.form(""cpaint_argument[]"")(" & i & ")"
				if i <> request.form("cpaint_argument[]").count then eval_string = eval_string & ", "
			next		
		end if
		if api_functions.exists(lcase(user_function)) = true then
			eval(user_function & " (" & eval_string & ")")
		else
			basenode.set_data "A function name was passed that is not allowed to execute on this server."
		end if
	end sub
	

	' generates and returns the response to the front-end
	' @access	public
	' @return	none
	Public Sub return_data
		response.Clear()
		response.ExpiresAbsolute = now()
		response.CacheControl = "Private"
		if request.querystring = "api_query" or request.form = "api_query" then
			response.contenttype = "text/plain"
			response.charset = "ISO-8859-1"
	        response.write("CPAINT v" & versionNumber & "/ASP-VBScript v" & ScriptEngineMajorVersion & "." & ScriptEngineMinorVersion & "." & ScriptEngineBuildVersion)
		else
			select case trim(ucase(response_type))
				case "TEXT"
					response.ContentType = "text/plain"
					response.charset = encoding
					response.write(basenode.toString)
				case "OBJECT", "XML"
					response.ContentType = "text/xml"
					response.charset = encoding
					response.write("<?xml version=""1.0"" encoding=""" & encoding & """?>")
					response.write(basenode.toXML)
				case else
					response.write("ERROR:  invalid response type """ & response_type & """")
			end select	
		end if

	end sub
	
	' adds a new node to the base node
	' @access	public
	' @param	string		nodename		name of the node
	' @param	string		id				the id attribute of the node
	' @return	cpaint_node
	public function add_node(nodename, id)
		set add_node = basenode.add_node(nodename, id)
	end function
	
	' sets the payload of the base node
	' @access	public
	' @param	string		data			payload of the node
	' @return	string
	public sub set_data(data)
		basenode.set_data data
	end sub
	
	' gets the payload data of the basenode
	' @access	public
	' @return	string
	public function get_data()
		get_data = basenode.get_data()
	end function
	
	' sets the id of the base node
	' @deprecated	deprecated since version 2.0.0
	' @access		public
	' @param		string		id			the id attribute of the node
	' @return		none
	public sub set_id(id)
		basenode.set_attribute "id", id
	end sub
	
	' gets the id attribute of the base node
	' @deprecated	deprecated since version 2.0.0
	' @access		public
	' @return		string
	public function get_id()
		get_id = basenode.get_attribute("id")
	end function
	
	' sets an attribute of the base node
	' @access	public
	' @param	string		aName		attribute name
	' @param	string		aValue		attribute value
	' @return	none
	public sub set_attribute(aName, aValue)
		basenode.set_attribute aName, aValue
	end sub
	
	' gets an attribute of the base node
	' @access	public
	' @param	string		aName		attribute name
	' @return	string
	public function get_attribute(aName)
		get_attribute = basenode.get_attributes(aName)
	end function
	
	' sets the tag name of the base node
	' @access	public
	' @param	string		tName
	' @return	none
	public sub set_name(tName)
		basenode.set_name tName
	end sub
	
	' gets the tag name of the base node
	' @access	public
	' @return	string
	public function get_name()
		get_name = basenode.get_name()
	end function
	
	' registers a new function or method as part of the CPAINT API
	' @note		This implementation is INCOMPATIBLE with the PHP implementation
	' @access	public
	' @param	string		function_name
	' @return	boolean
	public function register(function_name)
		return_value = false
		if api_functions.exists(lcase(function_name)) = true then
			return_value = true
		else
			api_functions.item(lcase(function_name)) = lcase(function_name)
			return_value = true
		end if
		register = return_value
		
	end function
End Class


' cpaint data node class
' @version	2.0.0
' @access	public
Class cpaint_node

	' array of sub-nodes
	' @access 	public
	' @var		cpaint_node
	public oComposites()
	
	' keyed array of attributes
	' @access	public
	' @var		Scripting.Dictionary
	public oAttributes
	
	' tag name of this node
	' @access	public
	' @var 		string
	public oNodename
	
	' data payload of this node
	' @access	public
	' @var 		string
	public oData
	
	' class initalizer
	' @access	private
	' @return	none
	private sub Class_Initialize()
		redim oComposites(0)
		set oAttributes = server.CreateObject("Scripting.Dictionary")
	end sub
	
	' adds a new sub-node to this node
	' NOTE:  nodename and id arguments are REQUIRED!  (blank string is ok for id)
	' @access	public
	' @param	string		nodename		name of new sub-node
	' @param	string		id				id attribute value of new sub-node
	' @return	cpaint_node
	public function add_node(nodename, id)
		newComposite = ubound(oComposites) + 1
		redim preserve oComposites(newComposite)
		set oComposites(newComposite) = new cpaint_node
		oComposites(newComposite).set_name nodename
		oComposites(newComposite).set_id id
		set add_node = oComposites(newComposite)
	end function	
	
	' sets the data payload for this node
	' @access	public
	' @param	string		data		data payload
	' @return	none
	public sub set_data(data)
		oData = data
	end sub
	
	' gets the data payload for this node
	' @access	public
	' @return	string
	public function get_data
		get_data = oData
	end function
	
	' sets the id attribute of this node
	' @deprecated	deprecated since v2.0.0
	' @access		public
	' @param		string		id		value of id attribute
	' @return		none
	public sub set_id(id)
		set_attribute "id", id
	end sub
	
	' gets the id attribute of this node
	' @deprecated	deprecated since v2.0.0
	' @access		public
	' @return		string
	public function get_id
		get_id = get_attributes("id")
	end function
	
	' sets an attribute for this node
	' @access	public
	' @param	string		aName		attribute name
	' @param	string		aValue		attribute value
	' @return	none
	public sub set_attribute(aName, aValue)
		oAttributes.Add aName, aValue
	end sub
	
	' gets the value of an attribute
	' @access	public
	' @param	string		aName		attribute name
	' @return	string
	public function get_attributes(aName)
		get_attributes = oAttributes.Item(aName)
	end function
	
	' sets the tag name for this node
	' @access	public
	' @param	string		tName		tag name
	' @return 	none
	public sub set_name(tName)
		oNodename = tName
	end sub
	
	' gets the tag name for this node
	' @access	public
	' @return	string
	public function get_name
		get_name = oNodename
	end function
	
	' used to generate response of type TEXT
	' @access	public
	' @return	string
	public function toString()
		return_value = ""
		for i = 1 to ubound(oComposites)
			return_value = return_value & oComposites(i).toString
		next
		return_value = return_value & encode(get_data)
		toString = return_value
	end function
	
	' used to generate response of type XML or OBJECT
	' @access	public
	' @return	string
	public function toXML()
		return_value = "<" & encode(get_name)
		for each sValue in oAttributes
			return_value = return_value & " " & encode(sValue) & "=""" & encode(oAttributes.Item(sValue)) & """"
		next
		return_value = return_value & ">"
		for i = 1 to ubound(oComposites)
			return_value = return_value & oComposites(i).toXML
		next
		return_value = return_value & encode(get_data) & "</" & encode(get_name) & ">"
		toXML = return_value
	end function
	
	' encodes characters for XML and JavaScript compatibility
	' @access	public
	' @param	string		data		the string to encode
	' @return	string
	public function encode(data)
		' since ASP performs character set encoding "automagically", we really don't need to (nor can we) perform character set conversion
		' replace <, >,  and & for sanity
		return_value = replace(data, chr(38), "\u0026")
		return_value = replace(return_value, chr(60), "\u003c")
		return_value = replace(return_value, chr(62), "\u003e")
		encode = return_value
	end function

end class
%>
